import React, { useMemo} from 'react'
import {
  Box, 
  // Paper,
  LinearProgress
} from '@mui/material'

import { Service } from '../../Utils/HTTP'
import useAuth from '../../Auth/useAuth.js';
import {Question} from '../../Components/Test/Cleaver/Question.jsx'


export function Cleaver() {

  let auth = useAuth();
  let token = useMemo(() => auth.getToken(), [auth])

  const [progress, setProgress] = React.useState(0);
  const [questions, setQuestions] = React.useState([]);
  const [buffer, setBuffer] = React.useState(10);

  const progressRef = React.useRef(() => {});

  React.useEffect(() => {

    let rest = new Service(`/prueba/findid/1`)
    rest.get(token.toString())
      .then(({data}) => { 
        console.log("RESP: ", data)
        setQuestions(data.questions)
      })
      .catch( e => console.log("ERROR: ", e))

    const timer = setInterval(() => {
      progressRef.current();
    }, 500);

    return () => {
      clearInterval(timer);
    };
  }, [token]);


  React.useEffect(() => {
    progressRef.current = () => {
      if (progress > 100) {
        setProgress(0);
        setBuffer(10);
      } else {
        const diff = Math.random() * 10;
        const diff2 = Math.random() * 10;
        setProgress(progress + diff);
        setBuffer(progress + diff + diff2);
      }
    };
  });

  return (
    <div className="content-section">
      <div className="main">
        <Box sx={{ width: '100%' , magin : 5}}>
          <LinearProgress style={{ margin : 5}} variant="buffer" value={progress} valueBuffer={buffer} />
        </Box>
        {
        questions.map( e => (<Question key={e.id} quiz={e}/>) )
      }
      </div>
    </div>
  )

}
